
import time

from invokable import JobStatus


class JobItem:

    def __init__(self, job_id, thread, invoke_item, status, inputs, data=None):
        self._thread = thread
        self._invoke_item = invoke_item
        self._job_id = job_id
        self._status = status
        self._inputs = inputs
        self._data = data

        self.outputs = None
        self._timeout = None

    @property
    def job_id(self):
        return self._job_id

    @property
    def status(self):
        return self._status

    @status.setter
    def status(self, value):
        self._status = value

    @property
    def timeout(self):
        return self._timeout

    @timeout.setter
    def timeout(self, value):
        self._timeout = value

    @property
    def is_timeout(self):
        return self._timeout and self._timeout < time.time()

    @property
    def outputs(self):
        return self._outputs

    @outputs.setter
    def outputs(self, value):
        self._outputs = value

    @property
    def is_done(self):
        status_done = [
            JobStatus.SUCCEEDED,
            JobStatus.FAILED,
            JobStatus.CANCELLED,
        ]
        return self._status in status_done

    @property
    def inputs(self):
        return self._inputs

    @property
    def data(self):
        return self._data
