"""

    Storage Module


"""

import re

from invokable.storage.storage import Storage                   # noqa: F401
from invokable.storage.storage_memory import StorageMemory
from invokable.storage.storage_sqlite import StorageSqlite


def load_from_string(info):
    result = None
    if re.match(r'mem', info):
        result = StorageMemory()
    elif re.match(r'sqlite', info):
        match = re.match(r'^sqlite[^\w](.*)', info)
        filename = match.group(1)
        result = StorageSqlite(filename)
    return result


def storage_load(info, default_result=None):
    result = default_result
    if info:
        result = info
        if isinstance(info, str):
            result = load_from_string(info)
    return result
