from abc import (
    ABC,
    abstractmethod
)


class Storage(ABC):

    @abstractmethod
    def items(self, name):
        return None

    @abstractmethod
    def read(self, name, asset_id):
        return None

    @abstractmethod
    def write(self, name, asset_id, data):
        return False

    @abstractmethod
    def is_stored(self, name, asset_id):
        return False

    @abstractmethod
    def clear(self, name=None):
        return False
