
from invokable.storage.storage import Storage


class StorageMemory(Storage):

    def __init__(self):
        self._data = {}

    def items(self, name):
        if name in self._data:
            return self._data[name]
        return {}

    def read(self, name, asset_id):
        if self.is_stored(name, asset_id):
            return self._data[name][asset_id]
        return None

    def write(self, name, asset_id, data):
        if name not in self._data:
            self._data[name] = {}
        self._data[name][asset_id] = data
        return True

    def is_stored(self, name, asset_id):
        return name in self._data and asset_id in self._data[name]

    def clear(self, name=None):
        if name:
            self._data[name] = {}
        else:
            self._data = {}
