"""

Test to see if starfish can call us


"""
import hashlib

from tests.resources.services.basic.hash_text import HashText
from invokable import InvokeHandler, JobStatus
from starfish.middleware.remote_agent_adapter import RemoteAgentAdapter

TEST_HASH_TEXT = 'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum eu congue odio, vel congue sapien. Morbi ac purus ornare, volutpat elit a, lacinia odio. Integer tempor tellus eget iaculis lacinia. Curabitur aliquam, dui vel vestibulum rhoncus, enim metus interdum enim, in sagittis massa est vel velit. Nunc venenatis commodo libero, vitae elementum nulla ultricies id. Aliquam erat volutpat. Cras eu pretium lacus, quis facilisis mauris. Duis sem quam, blandit id tempor in, porttitor at neque. Cras ut blandit risus. Maecenas vitae sodales neque, eu ultricies nibh.'


def test_starfish_invoke(client_secure, server_secure, remote_agent_invoke):


    message = hashlib.md5()
    message.update(TEST_HASH_TEXT.encode('utf-8'))
    hash_value = message.hexdigest()

    RemoteAgentAdapter.set_http_client(client_secure)

    invoke_handler = server_secure.invoke_handler
    print(invoke_handler.asset_list)
    invoke_item = invoke_handler.find_item('hash_text')
    assert(invoke_item)
    asset_id = invoke_item.asset_id
    asset = remote_agent_invoke.get_asset(asset_id)
    inputs = {
        'value': TEST_HASH_TEXT
    }
    response = remote_agent_invoke.invoke(asset, inputs)
    assert(response)
    assert(response['status'] == JobStatus.SUCCEEDED)
    assert(response['outputs']['hash_value'] == hash_value)
