"""

Invokable Service asset_get

"""

from invokable import InvokeService


class AssetDIDGet(InvokeService):

    name = 'asset_did_get'
    description = 'Get an asset registered on the Ocean Network'
    creator = 'Dex'
    modes = InvokeService.MODES_ALL
    inputs = {
        'did': {
            'type': 'string',
            'required': True
        }
    }
    outputs = {
        'acknowledge_list': {
            'type': 'array',
            'items': {
                'type': 'string'
            }
        }
    }
    tags = ['asset', 'did', 'get']

    def run(self, inputs, data):

        asset_data = data['asset_data']
        ref_id = inputs['ref_id']
        items = []
        for did, item in asset_data:
            if item['ref_id'] == ref_id:
                items.append(item['did'])

        return  {
            'items': items
        }
