"""

Invokable Service asset_get

"""

from invokable import InvokeService


class AssetInfoGet(InvokeService):


    name = 'asset_info_get'
    description = 'Get an asset registered on the Ocean Network'
    creator = 'Dex'
    modes = InvokeService.MODES_ALL
    inputs = {
        'did': {
            'type': 'string',
            'required': True
        }
    }
    outputs = {
        'extra_data': {
            'type': 'json'
        },
        'data': {
            'type': 'json'
        },
        'acknowledge_id_list': {
            'type': 'array',
            'items': {
                'type': 'string'
            }
        }
    }
    tags = ['asset', 'info', 'get']

    def run(self, inputs, data):

        asset_data = data['asset_data']
        did = inputs['did']
        if did in asset_data:
            item = asset_data[did]
            return {
                'extra_data': item['extra_data'],
                'data': item,
            }

        return f'{did} not found', 404
