"""

Invokable Service asset_list

"""

import time
from invokable import InvokeService


class AssetList(InvokeService):


    name = 'asset_list'
    description = 'List assets on the Ocean Network'
    creator = 'Dex'
    modes = InvokeService.MODES_ALL
    outputs = {
        'items': {
            'type': 'array',
            'items': {
                'type': 'string'
            }
        }
    }
    tags = ['asset', 'list']
    def run(self, inputs, data=None):

        asset_data = data['asset_data']
        time.sleep(1)
        items = []
        for did, item in asset_data.items():
            items.append(did)

        time.sleep(1)
        return {
            'items': items
        }
