"""

Invokable Service asset_register

"""

import secrets
from invokable import InvokeService


class AssetRegister(InvokeService):

    name = 'asset_register'
    description = 'Register a test asset'
    creator = 'Dex'
    modes = InvokeService.MODES_ALL
    inputs = {
        'ref_id': {
            'type': 'string',
            'required': True
        },
        'asset_list': {
            'type': 'array',
            'items': {
                'type': 'string'
            }
        }
    }
    outputs = {
        'listing_did': {
            'type': 'string'
        }
    }
    tags = ['asset', 'register']

    def run(self, inputs, data=None):
        asset_data = data['asset_data']
        ref_id = inputs['ref_id']
        asset_list = inputs.get('asset_list')
        extra_data = inputs
        asset_id = secrets.token_hex(16)
        did = f'did:dep:{asset_id}'
        asset_data[did] = {
            'asset_id': asset_id,
            'extra_data': extra_data,
            'ref_id': ref_id,
            'asset_list': asset_list,
        }
        return {
            'listing_did': did
        }
