"""

Invokable Service hash some text using decorators

"""

import hashlib
from invokable import InvokeService
from tests.conftest import get_server_instance

server_instance=get_server_instance()


@server_instance.invoke_handler.register
def hash_text_decorator(service, inputs, data=None):
    """

    Hash some text using invokbale services

    ---
    name: hash_text_2
    creator: Dex
    modes:
      - sync
      - async
    tags:
      - hash
      - text
    inputs:
      to_hash:
        type: string
        required: true
        description: item to hash
    outputs:
      hash_value:
        type: string
        description: return hash value of to_hash

    """
    message = hashlib.md5()
    message.update(inputs['to-hash'].encode('utf-8'))
    return {
        'hash_value': message.hexdigest()
    }
