"""

 Test Invoke Service Handler

"""

import pytest
import secrets
import datetime
import json
import re

# from server.api.users import get_user_list

from invokable import InvokeHandler, InvokeService

from tests.resources.services.asset.asset_register import AssetRegister
from tests.resources.services.asset.asset_acknowledge import AssetAcknowledge
from tests.resources.services.decorators.hash_text import hash_text_decorator


def test_register_class():
    handler = InvokeHandler()
    names = handler.register_class(AssetRegister)
    assert(names)
    assert('asset_register' in names)

def test_register_class_list():
    handler = InvokeHandler()
    names = handler.register_class([
        AssetRegister,
        AssetAcknowledge,
    ])
    assert(names)
    assert('asset_register' in names)
    assert('asset_acknowledge' in names)


def test_register_package():
    handler = InvokeHandler()
    names = handler.register_package('tests.resources.services.asset')
    assert(names)
    names_in_package = ['asset_acknowledge', 'asset_register']
    for name in names_in_package:
        assert(name in names)

def test_register_module():
    handler = InvokeHandler()
    names = handler.register_module('tests.resources.services.asset.asset_register')
    assert(names)
    assert('asset_register' in names)

def test_register_module_list():
    handler = InvokeHandler()
    names = handler.register_module([
        'tests.resources.services.asset.asset_register',
        'tests.resources.services.asset.asset_acknowledge',
    ])
    assert(names)
    assert('asset_acknowledge' in names)
    assert('asset_register' in names)

def test_register_decorator():
    inputs = {'to-hash': secrets.token_hex(64)}
    service = InvokeService()
    result = hash_text_decorator(service, inputs)
    print(result)
