"""

 Test Agent API

"""

import pytest
import json

from starfish.agent import RemoteAgent
from starfish.agent.services import Services


def test_get_ddo(client, site_path):

    services = Services(site_path.url)
    services.add('invoke', site_path.invoke)
    services.add('meta', site_path.meta)

    ddo = RemoteAgent.generate_ddo(services)
    url = f'{site_path.agent}/ddo'
    response = client.get(url)
    ddo = response.json
    assert(ddo)
    assert(isinstance(ddo, dict))
    assert(ddo['id'])


def test_get_status(client, site_path):


    url = f'{site_path.agent}/status'
    response = client.get(url)
    result = response.json
    assert(result)
    assert(result['name'])
    assert(result['description'])
