"""

 Test Metadata API

"""

import pytest
import secrets
import datetime
import json
import re

def test_get_metadata_list_authentication(client_secure, site_path, auth_token):

    headers = {
        'Authorization': f'token {auth_token}'
    }

    url = f'{site_path.meta}/data'
    response = client_secure.get(url, headers=headers)
    result = response.get_json()
    assert(result)
    print(result)


    headers = {
        'Authorization': f'this is a bad_token'
    }

    url = f'{site_path.meta}/data'
    response = client_secure.get(url, headers=headers)
    assert(response.status_code == 401)
    assert('WWW-Authenticate' in response.headers)
    assert(response.headers['WWW-Authenticate'] == 'Token realm="Authentication Required"')
